package com.zfire.jiasm.syncdata.service.impl;

import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zfire.jiasm.syncdata.plus.entity.*;
import com.zfire.jiasm.syncdata.plus.mapper.OrderBaseMapper;
import com.zfire.jiasm.syncdata.plus.service.*;
import com.zfire.jiasm.syncdata.response.WebsitFWS;
import com.zfire.jiasm.syncdata.service.OrderService;
import com.zfire.jiasm.syncdata.service.PublicService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class OrderServiceImpl extends ServiceImpl<OrderBaseMapper, OrderBase> implements OrderService {
    @Resource
    StreetService streetService;
    @Resource
    BrandLbsRelateService brandLbsRelateService;
    @Resource
    AreaService areaService;
    @Resource
    PublicService publicService;


    @Override
    public  void setPar(ItfTblAzAssignLcLsDownload item, OrderBase orderBase){
        WebsitFWS websitFWS = new WebsitFWS();

        // gpsaddress
        if (StringUtils.isEmpty(orderBase.getGpsAddress())){
            orderBase.setGpsAddress(publicService.getGpsaddress(orderBase.getLng(),orderBase.getLat()));
        }

        // 售后网点处理
        websitFWS = publicService.shshwdToptshwd(orderBase.getWebsitId(),orderBase);
        orderBase.setWebsitId(websitFWS.getWebsitId());
        orderBase.setWebsitName(websitFWS.getWdmc());
        orderBase.setGroupCompanyId(websitFWS.getGroupCompanyId());
        orderBase.setGroupCompanyName(websitFWS.getGroupCompanyName());
        orderBase.setProductBrandId("A");
        orderBase.setProductBrandName("格力(机型品牌)");



        // 接收派工网点处理 总力总部下来的接收网点信息不为空
        if (item.getAzwdno().equals(orderBase.getReceWebsitId())){
            orderBase.setReceWebsitId(orderBase.getWebsitId());
            orderBase.setReceWebsitName(orderBase.getWebsitName());
            // 结算主体
            orderBase.setBrandId(websitFWS.getBrandId());
            orderBase.setBrandName(websitFWS.getBrandName());

        } else {
            websitFWS = publicService.shshwdToptshwd(orderBase.getReceWebsitId(),orderBase);
            orderBase.setReceWebsitId(websitFWS.getWebsitId());
            orderBase.setReceWebsitName(websitFWS.getWdmc());
            // 结算主体
            orderBase.setBrandId(websitFWS.getBrandId());
            orderBase.setBrandName(websitFWS.getBrandName());
        }
        // 创建网点处理
        if (item.getAzwdno().equals(orderBase.getCreateWebsitId())){
            orderBase.setCreateWebsitId(orderBase.getWebsitId());
            orderBase.setCreateWebsitName(orderBase.getWebsitName());
        } else {
            websitFWS = publicService.shshwdToptshwd(orderBase.getCreateWebsitId(),orderBase);
            orderBase.setCreateWebsitId(websitFWS.getWebsitId());
            orderBase.setCreateWebsitName(websitFWS.getWdmc());
        }
        // 销售网点处理
        websitFWS = publicService.shxswdToptxswd(orderBase.getSaleWebsitId(),orderBase);
        orderBase.setSaleWebsitId(websitFWS.getWebsitId());
        orderBase.setSaleWebsitName(websitFWS.getWdmc());
        // 这里为商户的系统网点编号
        orderBase.setSaleWebsitSysNumber(websitFWS.getBrandSysWebsitNumber());

        // 判断安装网点编号是否为空或者为公司，如果为空或为公司，就写入接收派工网点
        if (StringUtils.isEmpty(item.getAzwdno()) || item.getAzwdno().equals("S9219801") || item.getAzwdno().equals("S9219807")){
            if (orderBase.getReceWebsitId() !=null){
                orderBase.setWebsitId(orderBase.getReceWebsitId());
                orderBase.setWebsitName(orderBase.getReceWebsitName());
            }
        }

        // 省市区单独处理
        shPositionTopt(orderBase);
        // 派工方式，新创建订单时 azren 名称不为空时为手动派工  （dispatch_flag派工方式 A=自动派工 B=手动派工）
        if (StringUtils.isNotEmpty(orderBase.getDispatchFlag())){
            orderBase.setDispatchFlag("B");
        } else {
            orderBase.setDispatchFlag("A");
        }

        // create_sys - 创建网点系统  cjwdno
        // last_operator_websit:最近操作网点 创建单时也是创建网点 可能是销售网点，也可能是售后网点  zjczwd
        // sys_websit_number 系统网点编号 zjczwd 同上
        orderBase.setCreateSys(orderBase.getCreateWebsitId());

        // 先从销售网点判断
        websitFWS = publicService.shxswdToptxswd(item.getXsdwno(),orderBase);
        if (StringUtils.isEmpty(websitFWS.getWebsitId())){
            websitFWS = publicService.shshwdToptshwd(item.getXsdwno(),orderBase);
        }
        orderBase.setLastOperatorWebsit(websitFWS.getWebsitId());
        orderBase.setSysWebsitNumber(websitFWS.getBrandSysWebsitNumber());

    }



    @Override
    public void setParame(Brand brand, OrderBase orderBase, ItfTblAssignDownload item) {
        WebsitFWS websitFWS = new WebsitFWS();

        // gpsaddress
        if (StringUtils.isEmpty(orderBase.getGpsAddress())){
            orderBase.setGpsAddress(publicService.getGpsaddress(orderBase.getLng(),orderBase.getLat()));
        }

        // 结算主体
        // (wxwdno、xjwdno)维修网点与派下级网点同时为空时  (cjwdno、xswdno)创建网点与销售网点都有值
        if (StringUtils.isNotEmpty(orderBase.getWebsitId())){
            websitFWS = publicService.shshwdToptshwd(orderBase.getWebsitId(),orderBase);
        } else {
            websitFWS = publicService.shxswdToptxswd(orderBase.getSaleWebsitId(),orderBase);
        }
        orderBase.setBrandId(websitFWS.getBrandId());
        orderBase.setBrandName(websitFWS.getBrandName());
        orderBase.setGroupCompanyId(websitFWS.getGroupCompanyId());
        orderBase.setGroupCompanyName(websitFWS.getGroupCompanyName());
        orderBase.setProductBrandId("A");
        orderBase.setProductBrandName("格力(机型品牌)");


        websitFWS = publicService.shshwdToptshwd(orderBase.getWebsitId(),orderBase);
        orderBase.setWebsitId(websitFWS.getWebsitId());
        orderBase.setWebsitName(websitFWS.getWdmc());

        // 总部下来的工单统一为待接收状态-派工状态
        orderBase.setDispatchStatus("DJS");

        // 省市区单独处理
        shPositionTopt(orderBase);

        // 派工方式，新创建订单时 azren 名称不为空时为手动派工  （dispatch_flag派工方式 A=自动派工 B=手动派工）
        if (StringUtils.isNotEmpty(orderBase.getDispatchFlag())){
            orderBase.setDispatchFlag("B");
        } else {
            orderBase.setDispatchFlag("A");
        }

        // 售后网点处理
        websitFWS = publicService.shshwdToptshwd(orderBase.getWebsitId(),orderBase);
        orderBase.setWebsitId(websitFWS.getWebsitId());
        orderBase.setWebsitName(websitFWS.getWdmc());
        // 接收派工网点处理
        websitFWS = publicService.shshwdToptshwd(orderBase.getReceWebsitId(),orderBase);
        orderBase.setReceWebsitId(websitFWS.getWebsitId());
        orderBase.setReceWebsitName(websitFWS.getWdmc());

        // 创建网点处理
        websitFWS = publicService.shshwdToptshwd(orderBase.getCreateWebsitId(),orderBase);
        orderBase.setCreateWebsitId(websitFWS.getWebsitId());
        orderBase.setCreateWebsitName(websitFWS.getWdmc());

        // 销售网点处理
        websitFWS = publicService.shxswdToptxswd(orderBase.getSaleWebsitId(),orderBase);
        orderBase.setSaleWebsitId(websitFWS.getWebsitId());
        orderBase.setSaleWebsitName(websitFWS.getWdmc());
        // 这里为商户的系统网点编号
        orderBase.setSaleWebsitSysNumber(websitFWS.getBrandSysWebsitNumber());

        // create_sys - 创建网点系统  cjwdno
        // last_operator_websit:最近操作网点 创建单时也是创建网点 可能是销售网点，也可能是售后网点  zjczwd
        // sys_websit_number 系统网点编号 zjczwd 同上
        // 先从销售网点查
        websitFWS = publicService.shxswdToptxswd(orderBase.getCreateSys(),orderBase);
        if (StringUtils.isEmpty(websitFWS.getWebsitId())){
            websitFWS = publicService.shshwdToptshwd(orderBase.getCreateSys(),orderBase);
        }
        orderBase.setCreateSys(websitFWS.getWebsitId());

        websitFWS = publicService.shxswdToptxswd(orderBase.getLastOperatorWebsit(),orderBase);
        if (StringUtils.isEmpty(websitFWS.getWebsitId())){
            websitFWS = publicService.shshwdToptshwd(orderBase.getLastOperatorWebsit(),orderBase);
        }
        orderBase.setLastOperatorWebsit(websitFWS.getWebsitId());
        orderBase.setSysWebsitNumber(websitFWS.getBrandSysWebsitNumber());
    }

    @Override
    public void shPositionTopt(OrderBase orderBase) {
        List<BrandLbsRelate> br;
        if (StringUtils.isNotEmpty(orderBase.getStreet())){
            // 提取格力总部的省市区街道信息
            Street street = streetService.lambdaQuery()
                    .eq(Street::getProvince, orderBase.getProvince())
                    .eq(Street::getCity, orderBase.getCity())
                    .eq(Street::getArea, orderBase.getArea())
                    .eq(Street::getStreet, orderBase.getStreet()).one();
            // 对应出平台的省市区街道信息 无对应关系时依总部的为准
            getPosition(orderBase, street);
        } else {
            // 总部区必选项
            Area area = areaService.lambdaQuery()
                    .eq(Area::getArea, orderBase.getArea()).one();
            Street st = new Street();
            if (area !=null){
                BeanUtils.copyProperties(area,st);
                getPosition(orderBase, st);
                orderBase.setStreet("");
            }
        }
    }

    // 平台工单地理位置转成商户工单地理位置
    @Override
    public void tpPositionTosh(ItfTblAzAssignLcLsUpload lcls){
        List<BrandLbsRelate> br;
        // 街道处理
        if (StringUtils.isNotEmpty(lcls.getXzhenid())){
            // 提取街道信息
            br = brandLbsRelateService.lambdaQuery()
                    .eq(BrandLbsRelate::getLbsStreetId, lcls.getXzhenid())
                    .eq(BrandLbsRelate::getDel,0)
                    .isNotNull(BrandLbsRelate::getStreetId).list();
            // 存在 即找到了省市区街道ID
            if (br !=null && br.size()>0){
                lcls.setSfenid(Long.valueOf(br.get(0).getProvinceId()));
                lcls.setCshiid(Long.valueOf(br.get(0).getCityId()));
                lcls.setXianid(Long.valueOf(br.get(0).getAreaId()));
                lcls.setXzhenid(br.get(0).getStreetId());

                Street street = streetService.lambdaQuery()
                        .eq(Street::getProvince, lcls.getSfenid())
                        .eq(Street::getCity, lcls.getCshiid())
                        .eq(Street::getArea, lcls.getXianid())
                        .eq(Street::getStreet, lcls.getXzhenid()).one();
                // 这里一定有
                if (street !=null){
                    lcls.setSfen(street.getProvince());
                    lcls.setCshi(street.getCity());
                    lcls.setXian(street.getArea());
                    lcls.setXzhen(street.getStreet());
                    return;
                }
            }
        }

        // 换街道信息时单独处理
        // 区为必选
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getLbsProvinceId, lcls.getSfenid())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getProvinceId).list();
        if (br !=null && br.size()>0){
            lcls.setSfenid(Long.valueOf(br.get(0).getProvinceId()));
        } else {
            // 省信息无时不再处理，以平台的为准
            return;
        }
        //市
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getLbsCityId, lcls.getCshiid())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getCityId).list();
        if (br !=null && br.size()>0){
            lcls.setCshiid(Long.valueOf(br.get(0).getCityId()));
        }
        //区
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getLbsDistrictId, lcls.getXianid())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getAreaId).list();
        if (br !=null && br.size()>0){
            lcls.setXianid(Long.valueOf(br.get(0).getAreaId()));
        }

        // 总部区必选
        Area area = areaService.lambdaQuery()
                .eq(Area::getAreaId, lcls.getXianid()).one();
        if (area !=null){
            lcls.setSfen(area.getProvince());
            lcls.setCshi(area.getCity());
            lcls.setXian(area.getArea());
        }
    }

    private void getPosition(OrderBase orderBase, Street street) {
        List<BrandLbsRelate> br;
        //省市区，有时无街道，这里不提取街道信息
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getDel,0)
                .eq(BrandLbsRelate::getProvinceId, street.getProvinceId())
                .eq(BrandLbsRelate::getCityId, street.getCityId())
                .eq(BrandLbsRelate::getAreaId, street.getAreaId())
                .isNotNull(BrandLbsRelate::getLbsProvinceId)
                .isNotNull(BrandLbsRelate::getLbsCityId)
                .isNotNull(BrandLbsRelate::getLbsDistrictId).list();
        if (br !=null && br.size()>0){
            //省
            orderBase.setProvinceId(br.get(0).getLbsProvinceId());
            orderBase.setProvince(br.get(0).getLbsProvinceName());
            //市
            orderBase.setCityId(br.get(0).getLbsCityId());
            orderBase.setCity(br.get(0).getLbsCityName());
            //区
            orderBase.setAreaId(br.get(0).getLbsDistrictId());
            orderBase.setArea(br.get(0).getLbsDistrictName());
        } else {
            // 找不到依总部的为准
            return;
        }

        if (StringUtils.isNotEmpty(orderBase.getStreet())){
            //街道单独处理
            br = brandLbsRelateService.lambdaQuery()
                    .eq(BrandLbsRelate::getDel,0)
                    .eq(BrandLbsRelate::getProvinceId, street.getProvinceId())
                    .eq(BrandLbsRelate::getCityId, street.getCityId())
                    .eq(BrandLbsRelate::getAreaId, street.getAreaId())
                    .eq(BrandLbsRelate::getStreetId,street.getStreetId())
                    .isNotNull(BrandLbsRelate::getLbsProvinceId)
                    .isNotNull(BrandLbsRelate::getLbsCityId)
                    .isNotNull(BrandLbsRelate::getLbsDistrictId)
                    .isNotNull(BrandLbsRelate::getLbsStreetId).list();
            if (br !=null && br.size()>0){
                orderBase.setStreetId(br.get(0).getLbsStreetId());
                orderBase.setStreet(br.get(0).getLbsStreetName());
            }
        }
    }

    private void getPCABack(OrderBase orderBase, Street street) {
        List<BrandLbsRelate> br;
        //省
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getProvinceId, street.getProvinceId())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getLbsProvinceId).list();
        if (br !=null && br.size()>0){
            orderBase.setProvinceId(br.get(0).getLbsProvinceId());
            orderBase.setProvince(br.get(0).getLbsProvinceName());
        }
        //市
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getCityId, street.getCityId())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getLbsCityId).list();
        if (br !=null && br.size()>0){
            orderBase.setCityId(br.get(0).getLbsCityId());
            orderBase.setProvince(br.get(0).getLbsCityName());
        }
        //区
        br = brandLbsRelateService.lambdaQuery()
                .eq(BrandLbsRelate::getAreaId, street.getAreaId())
                .eq(BrandLbsRelate::getDel,0)
                .isNotNull(BrandLbsRelate::getLbsDistrictId).list();
        if (br !=null && br.size()>0){
            orderBase.setAreaId(br.get(0).getLbsDistrictId());
            orderBase.setArea(br.get(0).getLbsDistrictName());
        }
    }

}
